<script lang="ts">
  let correctAnswer = "";
  const newGame = async () => {
    const response = await fetch(
      "https://random-words5.p.rapidapi.com/getMultipleRandom?count=1&wordLength=5",
      {
        method: "GET",
        headers: {
          "X-RapidAPI-Key": import.meta.env.VITE_X_RapidAPI_KEY,
          "X-RapidAPI-Host": "random-words5.p.rapidapi.com",
        },
      }
    );
    let result = await response.json();
    correctAnswer = result[0];
  };
  newGame();

  let currentAttempt = [];
  let inputValues = Array(30).fill("");

  let positions = [];
  for (let i = 1; i <= 6; i++)
    for (let j = 1; j <= 5; j++)
      positions.push("attempt-" + i + "-letter-" + j);
  let currentPosition = 0;

  const keyboard = [
    ["q", "w", "e", "r", "t", "y", "u", "i", "o", "p"],
    ["a", "s", "d", "f", "g", "h", "j", "k", "l"],
    ["enter", "z", "x", "c", "v", "b", "n", "m", "backspace"],
  ];

  let disableLetters = false;
  let disableBackspace = true;
  let disableEnter = true;
  let green = [];
  let yellow = [];
  let grey = [];
  let result = {
    result: "",
    title: "",
    para1: "",
    para2: "",
    para3: "",
  };
  const enterKey = (key: string) => {
    if (key.length === 1) {
      currentAttempt = [...currentAttempt, key];
      inputValues[currentPosition] = key;
      positions[currentPosition] &&
        !positions[currentPosition].endsWith("5") &&
        currentPosition++;
    } else if (key === "backspace") {
      currentAttempt.length > 0 &&
        currentAttempt.length < 5 &&
        currentPosition--;
      currentAttempt.length > 0 && (inputValues[currentPosition] = "");
      currentAttempt.pop();
    } else if (key === "enter") {
      const currentInputs = positions.slice(
        currentPosition - 4,
        currentPosition + 1
      );
      let correctAnswer2 = [...correctAnswer];
      for (let i in [0, 1, 2, 3, 4]) {
        if (currentAttempt[i] === correctAnswer2[i]) {
          green = [...green, currentInputs[i]];
          correctAnswer2[i] = "Green";
        }
      }
      for (let i in [0, 1, 2, 3, 4]) {
        if (correctAnswer2.includes(currentAttempt[i])) {
          yellow = [...yellow, currentInputs[i]];
          correctAnswer2[correctAnswer2.indexOf(currentAttempt[i])] = null;
        } else
          correctAnswer2[i] !== "Green" && (grey = [...grey, currentInputs[i]]);
      }
      currentAttempt = [];
      if (
        green.length >= 5 &&
        green
          .slice(green.length - 5, green.length)
          .every((i) => i[8] === green[green.length - 1][8])
      ) {
        result.result = "won";
        result.title = "You have won!";
        result.para1 = "Congratulations!";
        result.para2 =
          "You have completed the game in " +
          green[green.length - 1][8] +
          " attempt" +
          (Number(green[green.length - 1][8]) === 1 ? "." : "s.");
        newGame();
      } else if (currentPosition === positions.length - 1) {
        result.result = "lost";
        result.title = "Bad luck!";
        result.para1 = "You have run out of attempts.";
        result.para2 = `The correct answer is "${correctAnswer}".`;
        result.para3 =
          'Martin Luther King, Jr. once said, "We must accept finite disappointment, but never lose infinite hope."';
        newGame();
      }
      currentPosition++;
    }
    currentAttempt.length === 0
      ? (disableBackspace = true)
      : (disableBackspace = false);
    currentAttempt.length === 5
      ? ((disableLetters = true), (disableEnter = false))
      : ((disableLetters = false), (disableEnter = true));
  };
  const playAgain = () => {
    result.result = "";
    result.title = "";
    result.para1 = "";
    result.para2 = "";
    result.para3 = "";
    currentPosition = 0;
    green = [];
    yellow = [];
    grey = [];
    inputValues = Array(30).fill("");
  };
</script>

<header>
  <h1>Wordle</h1>
</header>

<main>
  <div class="answers">
    {#each positions as position}
      <div
        id={position}
        class={position === positions[currentPosition]
          ? "input input-focus"
          : "input"}
        class:green={green.includes(position)}
        class:yellow={yellow.includes(position)}
        class:grey={grey.includes(position)}
      >
        {inputValues[positions.indexOf(position)]}
      </div>
    {/each}
  </div>

  <div
    class="result"
    class:result-display={result.result !== ""}
    class:result-won={result.result === "won"}
    class:result-lost={result.result === "lost"}
  >
    <h2>{result.title}</h2>
    <div>
      <p>{result.para1}</p>
      <p>{result.para2}</p>
      {#if result.para3 !== ""}
        <p>{result.para3}</p>
      {/if}
    </div>
    <button on:click={playAgain}>Click to play again</button>
  </div>
  <div class="keyboard">
    {#each keyboard as keyboardRows}
      <div>
        {#each keyboardRows as key}
          <button
            id={"key-" + key}
            class:disabled={(key.length === 1 && disableLetters) ||
              (key === "enter" && disableEnter) ||
              (key === "backspace" && disableBackspace)}
            class={green.some(
              (i) => document.getElementById(i).innerHTML === key + " "
            )
              ? "green"
              : yellow.some(
                  (i) => document.getElementById(i).innerHTML === key + " "
                )
              ? "yellow"
              : grey.some(
                  (i) => document.getElementById(i).innerHTML === key + " "
                )
              ? "grey"
              : ""}
            on:click={() => enterKey(key)}
          >
            {key === "backspace" ? "←" : key}
          </button>
        {/each}
      </div>
    {/each}
  </div>
</main>

<footer>
  <p>Developed by Saad Shaikh</p>
</footer>
